#include <stdio.h>
#include <sys/stat.h>
#include <windows.h>
/*
2010/05/01
Copyright (C) 2010 Cryst. All rights reserved.
Version 1.0

vȌڍ
w肳ꂽBMPt@C̃wb_[̒lo܂B(oCi[f[^eLXg)
Color MAP f[^ɂ͑ΉĂ܂

BMPt@C̍\
+----------------------+----------------------
|  BITMAPFILEHEADER    |          ^
+----------------------+          |
|  BITMAPINFOHEADER    |      wb_[
+----------------------+          |
|  Color MAP (LUT)     |          |
| (biBitCount  24,   |          |
|   32 ȊO̎݁j  |          v
+----------------------+----------------------
|        :             |
|   IMAGE DATA         |      摜f[^[
|        :             |
+----------------------+----------------------

RpC@
gcc -Wall -mno-cygwin -o showBMPh showBMPh.c
*/
void    dumpBitmapFileHeader( BITMAPFILEHEADER *fh )
{
    fprintf( stdout, "\n" ) ;
    fprintf( stdout, "-- BITMAPFILEHEADER -- (%d Byte)\n", sizeof(BITMAPFILEHEADER) ) ;
    fprintf( stdout, "  unsigned short 2byte  \"BM\"     bfType        = 0x%2.2X\n", fh->bfType ) ;
    fprintf( stdout, "  unsigned long  4byte  P     bfSize        = %d\n", (unsigned int)fh->bfSize ) ;
    fprintf( stdout, "  unsigned short 2byte  0 Fixed  bfReserved1   = %d\n", fh->bfReserved1 ) ;
    fprintf( stdout, "  unsigned short 2byte  0 Fixed  bfReserved2   = %d\n", fh->bfReserved2 ) ;
    fprintf( stdout, "  unsigned long  4byte  Q     bfOffBits     = %d\n", (unsigned int)fh->bfOffBits ) ;
    fprintf( stdout, "   P t@CTCY[byte]\n" ) ;
    fprintf( stdout, "   Q t@C擪摜f[^܂ł̃ItZbg[byte]\n" ) ;
}

void    dumpBitmapInfoHeader( BITMAPINFOHEADER *ih )
{
    fprintf( stdout, "\n" ) ;
    fprintf( stdout, "-- BITMAPINFOHEADER -- (%d Byte)\n", sizeof(BITMAPINFOHEADER) ) ;
    fprintf( stdout, "  unsigned long  4byte  40 byte  biSize          = %d\n", (unsigned int)ih->biSize ) ;
    fprintf( stdout, "  long           4byte  摜̕ biWidth         = %d\n", (unsigned int)ih->biWidth ) ;
    fprintf( stdout, "  long     R  4byte  摜̍ biHeight        = %d\n", (unsigned int)ih->biHeight ) ;
    fprintf( stdout, "  unsigned short 2byte  1 Fixed  biPlanes        = %d\n", (unsigned int)ih->biPlanes ) ;
    fprintf( stdout, "  unsigned short 2byte  S     biBitCount      = %d\n", (unsigned int)ih->biBitCount ) ;
    fprintf( stdout, "  unsigned long  4byte  T     biCompression   = %d\n", (unsigned int)ih->biCompression ) ;
    fprintf( stdout, "  unsigned long  4byte  U     biSizeImage     = %d\n", (unsigned int)ih->biSizeImage ) ;
    fprintf( stdout, "  long           4byte H𑜓x   biXPelsPerMeter = %d\n", (unsigned int)ih->biXPelsPerMeter ) ;
    fprintf( stdout, "  long           4byte V𑜓x   biYPelsPerMeter = %d\n", (unsigned int)ih->biYPelsPerMeter ) ;
    fprintf( stdout, "  unsigned long  4byte  V     biClrUsed       = %d\n", (unsigned int)ih->biClrUsed ) ;
    fprintf( stdout, "  unsigned long  4byte dvF  biClrImportant  = %d\n", (unsigned int)ih->biClrImportant ) ;
    fprintf( stdout, "\n" ) ;
    fprintf( stdout, "   R :摜̏㕔̃f[^sPʂŏɊi[Ă\n" ) ;
    fprintf( stdout, "        :摜̉̃f[^sPʂŏɊi[Ă\n" ) ;
    fprintf( stdout, "        Ps̃f[^͕KSoCgEɔzuBȂꍇ̓_~[f[^u\n" ) ;
    fprintf( stdout, "        biSizeImage = abs(biHeight) * (biWidth + PsS̐{ɂ⊮f[^)\n" ) ;
    fprintf( stdout, "   S Frbg[bit] 1, 4, 8, (16), 24, 32\n" ) ;
    fprintf( stdout, "   T k`  0, 1, 2, 3  k`  0 ̏ꍇA摜f[^TCY 0łǂ\n" ) ;
    fprintf( stdout, "                  0 - BI_RGBikj\n" ) ;
    fprintf( stdout, "                  1 - BI_RLE8iRun-Length-Encoded 8bits/pixelj\n" ) ;
    fprintf( stdout, "                  2 - BI_RLE4iRun-Length-Encoded 4bits/pixelj\n" ) ;
    fprintf( stdout, "                  3 - BI_BITFIELDS\n" ) ;
    fprintf( stdout, "   U 摜f[^TCY[byte]    kȂ 0 łǂ\n" ) ;
    fprintf( stdout, "      𑜓x[dot/m]A𑜓x[dot/m] 0 ̏ꍇ\n" ) ;
    fprintf( stdout, "   V i[pbg[gpF]  biClrImporant:gpFœɏdvȐF\n" ) ;
    fprintf( stdout, "        biClrImporant: 0[Sďdv] or nbiClrUsed 擪 n ͏dvȐF\n" ) ;
}

int dumpBMP(char *filename)
{
BITMAPFILEHEADER  bmpFH ;
BITMAPINFOHEADER  bmpIH ;
struct stat       fileInfo ;
FILE              *fp = NULL;

    // t@Cwb_[̓ǂݍݕ
    if ( (fp=fopen(filename,"rb")) == NULL ) {
        fprintf( stderr, "'%s' open error.\n", filename ) ;
        return 1 ;
    } else if ( fstat(fileno(fp), &fileInfo) != 0 ) {
        fprintf( stderr, "'%s' fstat error.\n", filename ) ;
        fclose(fp) ;
        return 2 ;
    } else if( fileInfo.st_size < sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) ) {
        fprintf( stderr, "'%s' size error.\n", filename );
        fclose(fp) ;
        return 3 ;
    } else if ( fread(&bmpFH, sizeof(BITMAPFILEHEADER), 1, fp) != 1 ) {
        fprintf( stderr, "'%s' BITMAPFILEHEADER read error.\n", filename );
        fclose(fp) ;
        return 4 ;
    } else if ( fread(&bmpIH, sizeof(BITMAPINFOHEADER), 1, fp) != 1 ) {
        fprintf( stderr, "'%s' BITMAPINFOHEADER read error.\n", filename );
        fclose(fp) ;
        return 5 ;
    } else fclose(fp) ;

    // ȅo
    if( bmpFH.bfType != 0x4D42 ) { // BM   0x4D:M, 0x42:B
        fprintf( stdout, "\n'%s' Not BMP file.  size = %u Byte\n", filename, (unsigned int)fileInfo.st_size ) ;
        return 6 ;
    } else fprintf( stdout, "\n'%s': File size %u Byte\n", filename, (unsigned int)fileInfo.st_size ) ;
    dumpBitmapFileHeader(&bmpFH) ; // t@Cwb_[
    dumpBitmapInfoHeader(&bmpIH) ; // CtHwb_[
    return 0 ;
}

int main(int argc, char*argv[])
{
register int i ;

    if( argc == 1 ) {
        fprintf( stderr, "\nUsage: %s  BMP_File [BMP_File2 [BMP_File3 [...]]]\n\n", argv[0] ) ;
        return  1 ;
    } else for( i=1; i<argc; i++ ) dumpBMP( argv[i] ) ;
    return 0 ;
}
