#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <windows.h>
/* 摜vO̐`  conjunctioni摜Ԃ̘_Zj
2010/05/01
Copyright (C) 2010 Cryst. All rights reserved.
Version 1.0

vȌڍ
32rbg` BMP t@CԂ ANDAORAEXORA̘_ZsBʂ
V BMP t@CƂĕۑ܂B PZ NOTiSrbg]j\łB

̑
ȉ̊֐́AʂŎgp郋[`Ȃ̂ŁAʃt@CACuɂׂłA
p̃\[XR[hȂ̂ŁAĂPt@CɋLqĂ܂
int readBMPheader(char *, BITMAPFILEHEADER *, BITMAPINFOHEADER *, struct stat *)
int loadBMPimageFromFile(char *, unsigned int *, int)
int saveBMPimageOnMemory(char *, unsigned int *, int)

RpC@ (fobO)
O4 ݂Ȃꍇ́AO3 Ƃċ@\鎖ҁB386ȑO CPU ̓T|[gȂ
gcc -E -C -mno-cygwin -m486 bmp32lop.c                            // vvZbT݂̂̎s
gcc -E -C -DDEBUG -mno-cygwin -m486 bmp32lop.c                    // vvZbT݂̂̎s fobOΉ
gcc -g -DDEBUG -mno-cygwin -m486 -o bmp32lop bmp32lop.c           // fobOpRpC
GUI vO쐬́A -mconsole  IvVt鎖   gdb gȂA-g KC
gcc -g -DDEBUG -mno-cygwin -mconsole -m486 -o bmp32lop bmp32lop.c // GUIvÕfobOp


RpC@ (ʏ)
gcc -O4 -Wall -mno-cygwin -m486 -o bmp32lop bmp32lop.c
*/
// fobOp̊֐`
#ifdef DEBUG
#define DPRINTF( format, ... )   fprintf(stderr, "%s:%d\t" format, __FILE__,__LINE__,__VA_ARGS__)
#define IMHERE( ... )            fprintf(stderr, "%s:%d\t" __VA_ARGS__ "\n", __FILE__,__LINE__)
#else
#define DPRINTF( format, ... )
#define IMHERE( ... )
#endif
// error code definition
#define SAVEBMPONMEMORY_OPENERROR    1
#define SAVEBMPONMEMORY_SAVEERROR    2
#define READBMPFILE_OPENERROR        1
#define READBMPFILE_STATERROR        2
#define READBMPFILE_FILEERROR        3
#define READBMPFILE_READERROR        4
#define READBMPFILE_FORMATERROR      5
#define READBMPFILE_FORMATERROR2     6
#define READBMPFILE_UNSUPPORTFORMAT -1
#define BMPFILEERROR                 1
#define MEMORYALLOCERROR           100
#define OPERATIONERROR             200
#define SAVEBMPONMEMORYERROR       300
#define LOADBMPTOMEMORY_OPENERROR    1
#define LOADBMPTOMEMORY_LOADERROR    2


int readBMPheader(char *bmpName, BITMAPFILEHEADER *bmpFH, BITMAPINFOHEADER *bmpIH, struct stat *fileInfo)
{IMHERE("readBMPheader"); // BMPt@C̃wb_[̓ǂݍ݂ƊmF
register FILE *fp ;
register int  bytePerLine, headerSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) ;

    if ( (fp=fopen(bmpName,"rb")) == NULL ) {                          // t@C̃I[v
        return READBMPFILE_OPENERROR ;
    } else if ( fstat(fileno(fp), fileInfo) != 0 ) {                   // t@C̎擾
        fclose(fp) ;
        return READBMPFILE_STATERROR ;
    } else if ( fileInfo->st_size <= headerSize ) {                    // t@CTCY̊mF
        fclose(fp) ;
        return READBMPFILE_FILEERROR ;
    } else if ( fread(bmpFH, sizeof(BITMAPFILEHEADER), 1, fp) != 1 ) { // ̂̓ǂݍ
        fclose(fp) ;
        return READBMPFILE_READERROR ;
    } else if ( fread(bmpIH, sizeof(BITMAPINFOHEADER), 1, fp) != 1 ) { // ̂̓ǂݍ
        fclose(fp) ;
        return READBMPFILE_READERROR ;
    } else fclose(fp) ;
    // t@C̏񂪐̊mF
    if ( (bmpFH->bfType != 0x4D42) || (bmpFH->bfReserved1 != 0) || (bmpFH->bfReserved2 != 0) || (bmpIH->biPlanes != 1) ) {
        return READBMPFILE_FORMATERROR ;
    } else if ( (bmpIH->biSize != 40) || (bmpIH->biCompression != 0) ||
                ((bmpIH->biBitCount != 8)&&(bmpIH->biBitCount != 24)&&(bmpIH->biBitCount != 32)) ) {
        return READBMPFILE_UNSUPPORTFORMAT ;
    } else bytePerLine = (bmpIH->biWidth * (bmpIH->biBitCount>>3) +3) & ~3 ;
    if ( (bmpIH->biSizeImage < bytePerLine * abs(bmpIH->biHeight)) || (bmpFH->bfSize < (bmpIH->biSizeImage + bmpFH->bfOffBits)) ) {
        return READBMPFILE_FORMATERROR2 ;
    }
    return 0 ;
}

int loadBMPimageFromFile(char *filename, unsigned int *data, int len)
{IMHERE("loadBMPimageFromFile"); // f[^̓ǂݍ݁iBMP t@C̈ꊇǂݍ݂Ŏgpj
register FILE *fp ;

    if ( (fp=fopen(filename,"rb")) == NULL ) {        // t@C̃I[v
        return LOADBMPTOMEMORY_OPENERROR ;
    } else if ( fread(data, len, 1, fp) != 1 ) {
        return LOADBMPTOMEMORY_LOADERROR ;
    } else fclose(fp) ;
    return 0 ;
}

int saveBMPimageOnMemory(char *filename, unsigned int *data, int len)
{IMHERE("saveBMPimageOnMemory"); // f[^̏oiBMP t@C̈ꊇoŎgpj
register FILE *fp ;

    if ( (fp=fopen(filename,"wb")) == NULL ) {        // t@C̃I[v
        return SAVEBMPONMEMORY_OPENERROR ;
    } else if ( fwrite(data, len, 1, fp) != 1 ) {
        return SAVEBMPONMEMORY_SAVEERROR ;
    } else fclose(fp) ;
    return 0 ;
}

inline void operationAND(unsigned int *src1, unsigned int *src2, int wlx, int wly)
{IMHERE("operationAND"); // 摜Ԃ̘_Z RGBf[^ꊇ  AND
register unsigned int *d=src1, *s=src2, x, y, lx=wlx, ly=wly ;

    for( y=0; y<ly; y++ ) {               // 摜́Alx * ly ̑傫
        for( x=0; x<lx; d++, s++, x++ ) {
            *d &= *s ;                    // 4oCgiARGBj (unsigned int) ƌĂĈꊇ
            *d &= 0x00FFFFFF ;            // ʂ̗\GA(A) 1oCgNA
        }
    }
}

inline void operationOR(unsigned int *src1, unsigned int *src2, int wlx, int wly)
{IMHERE("operationOR"); // 摜Ԃ̘_Z RGBf[^ꊇ  OR
register unsigned int *d=src1, *s=src2, x, y, lx=wlx, ly=wly ;

    for( y=0; y<ly; y++ ) {               // 摜́Alx * ly ̑傫
        for( x=0; x<lx; d++, s++, x++ ) {
            *d |= *s ;                    // 4oCgiARGBj (unsigned int) ƌĂĈꊇ
            *d &= 0x00FFFFFF ;            // ʂ̗\GA(A) 1oCgNA
        }
    }
}

inline void operationEXOR(unsigned int *src1, unsigned int *src2, int wlx, int wly)
{IMHERE("operationEXOR"); // 摜Ԃ̘_Z RGBf[^ꊇ  EXOR
register unsigned int *d=src1, *s=src2, x, y, lx=wlx, ly=wly ;

    for( y=0; y<ly; y++ ) {               // 摜́Alx * ly ̑傫
        for( x=0; x<lx; d++, s++, x++ ) {
            *d ^= *s ;                    // 4oCgiARGBj (unsigned int) ƌĂĈꊇ
            *d &= 0x00FFFFFF ;            // ʂ̗\GA(A) 1oCgNA
        }
    }
}

inline void operationNOT(unsigned int *src1, unsigned int *src2, int wlx, int wly)
{IMHERE("operationNOT"); // 摜Ԃ̘_Z RGBf[^ꊇ  NOT
register unsigned int *d=src1, *s=src2, x, y, lx=wlx, ly=wly ;

    for( y=0; y<ly; y++ ) {               // 摜́Alx * ly ̑傫
        for( x=0; x<lx; d++, s++, x++ ) {
            *d = 0x00FFFFFF & (~(*s)) ;  // 4oCgiARGBj (unsigned int) ƌĂĈꊇ
        }                                // Ɠɏʂ̗\GA(A) 1oCgNA
    }
}

void operation(char op, unsigned int *src1, unsigned int *src2, int lx, int ly)
{IMHERE("operation"); // 摜Ԃ̘_Z̐U蕪  NOT AND OR EXOR
    fprintf( stdout, "operation code: '%c'.\n", op ) ;
    switch(op) {
        case '~':
            operationNOT(src1, src2, lx, ly) ;
            break;
        case '&':
            operationAND(src1, src2, lx, ly) ;
            break;
        case '|':
            operationOR(src1, src2, lx, ly) ;
            break;
        case '^':
            operationEXOR(src1, src2, lx, ly) ;
            break;
        default:
            break;
    }
}

int processing(char *fnameDist, char op, char *fnameSrc1, char *fnameSrc2org)
{IMHERE("operation"); // t@C̊mFAƃGÅmہAf[^̓ǂݍ݁Aۂ̏̌ĂяoA㏈
BITMAPFILEHEADER bmpFHsrc1, bmpFHsrc2 ;
BITMAPINFOHEADER bmpIHsrc1, bmpIHsrc2 ;
struct stat      fileInfoS1, fileInfoS2 ;
unsigned int     *memorySrc1, *memorySrc2 ;
unsigned int     *dataSrc1, *dataSrc2 ;
char             fnameSrc2[MAX_PATH] ;
register int     retv, lx, ly, dataSize ;

    if( op == '~' ) strcpy(fnameSrc2, fnameSrc1) ;    // PZΉ
    else            strcpy(fnameSrc2, fnameSrc2org) ;
    
    if( (retv=readBMPheader(fnameSrc1, &bmpFHsrc1, &bmpIHsrc1, &fileInfoS1)) != 0 ) {       //̓t@CP̊mF
        fprintf( stderr, "'%s' bad bmp file. %d\n", fnameSrc1, retv ) ;
        return BMPFILEERROR ;
    } else if( (retv=readBMPheader(fnameSrc2, &bmpFHsrc2, &bmpIHsrc2, &fileInfoS2)) != 0 ) {//̓t@CQ̊mF
        fprintf( stderr, "'%s' bad bmp file. %d\n", fnameSrc2, retv ) ;
        return BMPFILEERROR ;
    } else if ( (bmpIHsrc1.biBitCount != 32) || (bmpIHsrc2.biBitCount != 32) ) { 
        fprintf( stderr, "Either is not 32bit format.\n" ) ;
        return BMPFILEERROR ; // 2̓̓t@C32rbg`BMPt@CłȂꍇ
    } else if ( (bmpIHsrc1.biWidth != bmpIHsrc2.biWidth) || (bmpIHsrc1.biHeight != bmpIHsrc2.biHeight) ) {
        fprintf( stderr, "A size of the image or the direction is different.\n" ) ;
        return BMPFILEERROR ; // 2̓̓t@C̑傫قȂĂꍇ
    } else { // 2̓̓t@C̎ۂ̑傫̊mF
        lx       = bmpIHsrc1.biWidth ;
        ly       = abs(bmpIHsrc1.biHeight) ;
        dataSize = lx * ly * sizeof(unsigned int) ;
        if ( fileInfoS1.st_size < (dataSize + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) ) {
            fprintf( stderr, "'%s' file size error.\n", fnameSrc1 ) ;
            return BMPFILEERROR ;
        } else if ( fileInfoS2.st_size < (dataSize + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) ) {
            fprintf( stderr, "'%s' file size error.\n", fnameSrc2 ) ;
            return BMPFILEERROR ;
        }
    }
    if ( (memorySrc1=(unsigned int *)malloc(fileInfoS1.st_size)) == NULL ){        //̓t@CP̓ǂݍ݃GÅm
        fprintf( stderr, "Couldn't allocate memory. for src1(%dbyte)\n", (int)fileInfoS1.st_size ) ;
        return MEMORYALLOCERROR ;
    } else if ( (memorySrc2=(unsigned int *)malloc(fileInfoS2.st_size)) == NULL ){ //̓t@CQ̓ǂݍ݃GÅm
        free(memorySrc1) ;
        fprintf( stderr, "Couldn't allocate memory. for src2(%dbyte)\n", (int)fileInfoS2.st_size ) ;
        return MEMORYALLOCERROR ;
    } else {                                                                       //摜f[^̊i[ĂAhX̎Zo
        dataSrc1 = (unsigned int *)((unsigned char *)memorySrc1 + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) ;
        dataSrc2 = (unsigned int *)((unsigned char *)memorySrc2 + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) ;
    }

    if ((retv=loadBMPimageFromFile(fnameSrc1, memorySrc1, fileInfoS1.st_size)) != 0) {       // ̓t@CP̓ǂݍ
        free(memorySrc2) ;
        free(memorySrc1) ;
        fprintf( stderr, "bmp read error. (%s:%d)\n", fnameSrc1, retv ) ;
        return LOADBMPTOMEMORY_LOADERROR ;
    } else if ((retv=loadBMPimageFromFile(fnameSrc2, memorySrc2, fileInfoS2.st_size)) != 0) { // ̓t@CQ̓ǂݍ
        free(memorySrc2) ;
        free(memorySrc1) ;
        fprintf( stderr, "bmp read error. (%s:%d)\n", fnameSrc2, retv ) ;
        return LOADBMPTOMEMORY_LOADERROR ;
    }

    // fobNp̏ȏ͕}B  ʏRpCł̓R[h͐ȂBiRgƓlj
    DPRINTF("OP='%c', address1=0x%p, address2=0x%p, lx=%d, ly=%d\n", op, dataSrc1, dataSrc2, lx, ly) ;
    operation(op, dataSrc1, dataSrc2, lx, ly) ;                // ̓t@CPA̓t@CQł̉摜ԉŽĂяo

    if ( saveBMPimageOnMemory(fnameDist, memorySrc1, fileInfoS1.st_size) != 0 ) { // 摜ԉZʂBMPt@CƂĕۑ
        fprintf( stderr, "file write error.\n" ) ;
        free(memorySrc2) ; free(memorySrc1) ; return SAVEBMPONMEMORYERROR ;
    }
    free(memorySrc2) ;  // ̓t@CQ̍ƃGÅJ
    free(memorySrc1) ;  // ̓t@CP̍ƃGÅJ
    return 0 ;
}

void usage( int status )
{IMHERE("usage"); // R}h̎g̐
    fprintf( stderr, "\n\n" ) ;
    fprintf( stderr, "Usage: bmp32lop  dist.bmp = { OPE1 src.bmp | src1.bmp OPE2 src2.bmp}\n\n" ) ;
    fprintf( stderr, "Usage: bmp32lop  dist.bmp = { OPE1 src.bmp | src1.bmp OPE2 src2.bmp}\n\n" ) ;
    fprintf( stderr, "            dist.bmp = NOT src.bmp \n" ) ;
    fprintf( stderr, "            dist.bmp = src1.bmp OPE src2.bmp\n" ) ;
    fprintf( stderr, "                  OPE1: not\n" ) ;
    fprintf( stderr, "                       Invert operation:  dist.bmp = 0x00FFFFFF & (~src.bmp)\n" ) ;
    fprintf( stderr, "                  OPE2: and, or, exor\n" ) ;
    fprintf( stderr, "                          AND operation:  dist.bmp = src1.bmp & src2.bmp\n" ) ;
    fprintf( stderr, "                           OR operation:  dist.bmp = src1.bmp | src2.bmp\n" ) ;
    fprintf( stderr, "                         EXOR operation:  dist.bmp = src1.bmp ^ src2.bmp\n" ) ;
    fprintf( stderr, "\n" ) ;
    fprintf( stderr, "                         The logical operation between bmp files.\n" ) ;
    fprintf( stderr, "                         (32bit no-compressed Windows BMP file format)\n\n" ) ;
    exit( status ) ;
}

char opCheck(char *op)
{IMHERE("opCheck"); // w肳ꂽIy[V[h̊mF or and not exor 
register int l = strlen(op) ;

    if( l>4 || l<2 ) return '\0' ;
    else if ( l==2 ) {
        if (tolower(*(op+0))=='o' && tolower(*(op+1))=='r' ) return '|' ;
    } else if ( l==3 ) {
        if (tolower(*(op+0))=='a' && tolower(*(op+1))=='n' && tolower(*(op+2))=='d' ) return '&' ;
        if (tolower(*(op+0))=='n' && tolower(*(op+1))=='o' && tolower(*(op+2))=='t' ) return '~' ;
    } else {
        if (tolower(*(op+0))=='e' && tolower(*(op+1))=='x' && tolower(*(op+2))=='o' && tolower(*(op+3))=='r' ) return '^' ;
    }
    return '\0' ;
}

int main(int argc, char *argv[])
{// BMPt@CpA摜Ԃ̘_ZvO
char   op='\0', fnameSrc1[MAX_PATH], fnameSrc2[MAX_PATH], fnameDist[MAX_PATH] ;

    if ( (argc<5) || (argc>6) || (strlen(argv[2])!=1) || ((*argv[2])!='=') ) {
        usage(1) ;
    } else if ( argc == 5 ) {
        if ( (op=opCheck(argv[3])) == '\0') usage(1) ;
        else if (op!='~') usage(1) ;
        snprintf(fnameDist, MAX_PATH -1, "%s" , argv[1]) ;
        snprintf(fnameSrc1, MAX_PATH -1, "%s" , argv[4]) ;
        fnameSrc2[0] = '\0' ;
    } else {
        if ( (op=opCheck(argv[4])) == '\0') usage(1) ;
        else if (op=='~') usage(1) ;
        snprintf(fnameDist, MAX_PATH -1, "%s" , argv[1]) ;
        snprintf(fnameSrc1, MAX_PATH -1, "%s" , argv[3]) ;
        snprintf(fnameSrc2, MAX_PATH -1, "%s" , argv[5]) ;
    }
    return processing(fnameDist, op, fnameSrc1, fnameSrc2) ;
}
